/**
 * Musterprojekt Softwaretechnik
 * Copyright (c) 2015 by Institut für SoftwareArchitektur, TH Mittelhessen.
 * Lizenz Creative Commons CC BY-NC-SA 3.0
 */
package usg.lernkarten.data;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 *  Entity that represents a flashcard.
 */
public class Flashcard implements Serializable {

    private Integer id;
    private String question;
    private Integer numberOfCorrect;
    private Integer numberOfWrong;
    private Long lastCorrect;
    private Long lastPlayed;
    private Deck deck;

    private List<Picture> pictures;

    public Flashcard() {
        pictures = new ArrayList<>();
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getQuestion() {
        return question;
    }

    public void setQuestion(String question) {
        this.question = question;
    }

    public Integer getNumberOfCorrect() {
        return numberOfCorrect;
    }

    public void setNumberOfCorrect(Integer numberOfCorrect) {
        this.numberOfCorrect = numberOfCorrect;
    }

    public Integer getNumberOfWrong() {
        return numberOfWrong;
    }

    public void setNumberOfWrong(Integer numberOfWrong) {
        this.numberOfWrong = numberOfWrong;
    }

    public Long getLastCorrect() {
        return lastCorrect;
    }

    public void setLastCorrect(Long lastCorrect) {
        this.lastCorrect = lastCorrect;
    }

    public Long getLastPlayed() {
        return lastPlayed;
    }

    public void setLastPlayed(Long lastPlayed) {
        this.lastPlayed = lastPlayed;
    }

    public Deck getDeck() {
        return deck;
    }

    public void setDeck(Deck deck) {
        this.deck = deck;
    }

    public List<Picture> getPictures() {
        return pictures;
    }

    public void setPictures(List<Picture> pictures) {
        this.pictures = pictures;
    }

    public void addPicture(Picture picture) {
        if (pictures == null) {
            pictures = new ArrayList<>();
        }

        pictures.add(picture);
    }

    public void increaseNumberOfWrongBy(Integer nr) {
        this.numberOfWrong += nr;
    }

    public void increaseNumberOfCorrectBy(Integer nr) {
        this.numberOfCorrect += nr;
    }

    public void setLastPlayedNow() {
        this.lastPlayed = (new Date()).getTime();
    }

    public void setLastCorrectNow() {
        this.lastCorrect = (new Date()).getTime();
    }

    @Override
    public String toString() {
        return this.question == null ? "" : this.question;
    }

    @Override
    //this method has been generated by Android Studio
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Flashcard flashcard = (Flashcard) o;

        if (id != null ? !id.equals(flashcard.id) : flashcard.id != null) return false;
        if (question != null ? !question.equals(flashcard.question) : flashcard.question != null)
            return false;
        if (numberOfCorrect != null ? !numberOfCorrect.equals(flashcard.numberOfCorrect) : flashcard.numberOfCorrect != null)
            return false;
        if (numberOfWrong != null ? !numberOfWrong.equals(flashcard.numberOfWrong) : flashcard.numberOfWrong != null)
            return false;
        if (lastCorrect != null ? !lastCorrect.equals(flashcard.lastCorrect) : flashcard.lastCorrect != null)
            return false;
        if (lastPlayed != null ? !lastPlayed.equals(flashcard.lastPlayed) : flashcard.lastPlayed != null)
            return false;
        if (deck != null ? !deck.equals(flashcard.deck) : flashcard.deck != null) return false;
        return !(pictures != null ? !pictures.equals(flashcard.pictures) : flashcard.pictures != null);

    }

    @Override
    //this method has been generated by Android Studio
    public int hashCode() {
        return id != null ? id.hashCode() : 0;
    }
}
